/*
	Coded By calcite
	Date: June 6,2006
	setec.org/~calcite/
	Email: cold.r.us@gmail.com	

*/


/*
	Description:
			Tiny tool I wrote while looking into fuzzing. Generates
			random data to user defined environment variables.
			It maybe tiny, but can be usefull in the Aid in finding vulnerabilies.
			Lots of applications rely on environment variables to control execution, which gives rde a wide 
			area of applications to test on. Tested on Gentoo linux i686 arch , GCC version 4.0 .	
*/

/*
	compile:
		gcc rde.c -o rde
*/

/*
	Files : conf
	
		configuration for goes as
		<varname> <varsize> <perm>

		<varname>: The name of the environment variable you want to create
		<varsize>: The size of the value to be asigned to varname.
		<perm>: if this equals 1 then if the variable <varname> still exist, it will be over written
		if 0 then the value remains the same

*/

/*
	calcite@S3c-Rsrch ~/code/fuzz/rde $ ./rde conf
	Evar-> TESTVAR1|size->30|perm->1
	Evar-> TESTVAR2|size->60|perm->0
	Evar-> TESTVAR3|size->90|perm->1
	sh-3.00$ echo $TESTVAR1
		3CAOX꠫[B
		 
	sh-3.00$ echo $TESTVAR2
		!_4 Yo7PV[NܨM\RkǢJNk-S-
	sh-3.00$ echo $TESTVAR3
		;{'*Q?sgBb&8R v<l?0u$F
	sh-3.00$
*/

#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<string.h>
#include<time.h>
#include<sys/types.h>
#include<sys/stat.h>
#include<fcntl.h>

#define PGNAME "RDE"
//location of our source of random data
#define RANDOM  "/dev/random"
//Maximum size of a line
#define LINE 700
//Maximum size of a variable
#define ENVSIZE 500
//The max size of a memory allocation
#define MAXSIZE 8000
//Should we quit if we can't create a environment variable
// 1 == Quit 0 == Continue
#define QUIT 1 

void *memAlloc(unsigned int size);
char *rdata(unsigned int size);  
int _fuzz_env(char *_Evar,unsigned int size,unsigned int perm);


int main(int argc, char *argv[]) {
	FILE *fd;
	unsigned int size,perm;
	char *fuzzfile = NULL,*_fdata = NULL,env[ENVSIZE];
	argv[0] = PGNAME; //just felt like retaining the name :P
	if(argc != 2) {
		printf("Usage: %s <fuzz file>\n",argv[0]);
		exit(-1);
	}

	fuzzfile = argv[1];
	if(access(fuzzfile,F_OK) < 0) {
		fprintf(stderr,"File non existant\n");
		return -1;
	}	
	if((fd = fopen(fuzzfile,"r")) != NULL) {
		_fdata = memAlloc(LINE+1);		
		while(fgets(_fdata,LINE,fd)) {
			sscanf(_fdata,"%499s %d %d",env,&size,&perm);	
			if((size == 0) || (size > MAXSIZE)) {
				fprintf(stderr,"invalid size argument");
				free(_fdata);
				exit(-1);
			}
			if((perm != 0 ) && (perm != 1)) {
				fprintf(stderr,"invalid perm argument of %d",perm);
				free(_fdata);
				exit(-1);
			}
			printf("Evar-> %s|size->%d|perm->%d\n",env,size,perm);
			_fuzz_env(env,size,perm);
		}
		free(_fdata);
		system("/bin/sh");
		return 0;
	}	
	fprintf(stderr,"Error while opening %s\n",fuzzfile);
	return -1;
}	

char *rdata(unsigned int size) {
	register int i =0;
	unsigned int num;
	char *buf = NULL, *ptr = NULL,test;
	buf = memAlloc(size+1);
	srand(getseed());
	ptr = buf;
	while(i < size) {
		REDO:
			num = rand() % 1000;
			test = (char)num;
			if(test) {
				*ptr++ = (char)num;	
				i++;
			}else {
				goto REDO;
			}
	}	
	*ptr++ = 0x00;
	return buf;
	
}
int getseed(void) {
	int fd;
	unsigned int s;
	fd = open("/dev/random",O_RDONLY);
	read(fd,&s,sizeof(s));
	return s;
}
int _fuzz_env(char *_Evar, unsigned int size, unsigned int perm) {	
	char *data = NULL;
	data = rdata(size); //random characters
	if((setenv(_Evar,data,perm)) < 0) {
		if(QUIT == 1) {
			free(data);
			fprintf(stderr,"Error,could not create variable %s\n",_Evar);
			fprintf(stderr,"Very possible cause can be insufficient space\n");
			exit(-1);
		}
		
	}	
	return 0;
}

void *memAlloc(unsigned int size) {
	void *mem = NULL;
	if((mem = malloc(size)) == NULL) {
			fprintf(stderr,"Error when allocating %d of memory\n",size);
			exit(-1);
	}	
	memset(mem,0x00,size);
	return mem;
}
